/* Console Csound using the Csound API. */

#include <stdio.h>
#include <stdarg.h>
#include "csound.h"

void 
csoundMessage0(const char *format, ...)
{
  va_list args;
  va_start(args, format);
  vprintf(format, args);
  va_end(args);
}

#ifdef WINDOWS
extern int Graphable_();
extern void MakeGraph_(WINDAT *, char *);
extern void DrawGraph_(WINDAT *);
extern void KillGraph_(WINDAT *);
extern int ExitGraph_();

static void
cMakeGraph(void *csound, WINDAT *windat, char *name)
{
  MakeGraph_(windat, name);
}

static void
cDrawGraph(void *csound, WINDAT *windat)
{
  DrawGraph_(windat);
}

static void
cKillGraph(void *csound, WINDAT *windat)
{
  KillGraph_(windat);
}

static int 
cExitGraph(void *csound)
{
  return ExitGraph_();
}
#endif

int main(int argc, char **argv)
{
  int rc;
  void *csound = csoundCreate(0);
#if defined WINDOWS
  rc = Graphable_();
  csoundSetIsGraphable(csound, rc);
  if (rc) {
    csoundSetMakeGraphCallback(csound, cMakeGraph);
    csoundSetDrawGraphCallback(csound, cDrawGraph);
    csoundSetKillGraphCallback(csound, cKillGraph);
    csoundSetExitGraphCallback(csound, cExitGraph);
  }
#endif
  rc = csoundPerform(csound, argc, argv);
  csoundCleanup(csound);
  csoundReset(csound);
  return rc;
}
